/* ***********************************************************
 * This file was automatically generated on 2017-05-11.      *
 *                                                           *
 * C# Bindings Version 2.1.14                                *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

using System;

namespace Tinkerforge
{
	/// <summary>
	///  Reads and writes NFC and RFID tags
	/// </summary>
	public class BrickletNFCRFID : Device
	{
		/// <summary>
		///  Used to identify this device type in
		///  <see cref="Tinkerforge.IPConnection.EnumerateCallback"/>.
		/// </summary>
		public static int DEVICE_IDENTIFIER = 246;

		/// <summary>
		///  The display name of this device.
		/// </summary>
		public static string DEVICE_DISPLAY_NAME = "NFC/RFID Bricklet";

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpectedAll"/>.
		/// </summary>
		public const byte FUNCTION_REQUEST_TAG_ID = 1;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpectedAll"/>.
		/// </summary>
		public const byte FUNCTION_GET_TAG_ID = 2;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpectedAll"/>.
		/// </summary>
		public const byte FUNCTION_GET_STATE = 3;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpectedAll"/>.
		/// </summary>
		public const byte FUNCTION_AUTHENTICATE_MIFARE_CLASSIC_PAGE = 4;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpectedAll"/>.
		/// </summary>
		public const byte FUNCTION_WRITE_PAGE = 5;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpectedAll"/>.
		/// </summary>
		public const byte FUNCTION_REQUEST_PAGE = 6;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpectedAll"/>.
		/// </summary>
		public const byte FUNCTION_GET_PAGE = 7;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpectedAll"/>.
		/// </summary>
		public const byte CALLBACK_STATE_CHANGED = 8;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpectedAll"/>.
		/// </summary>
		public const byte FUNCTION_GET_IDENTITY = 255;


		/// <summary>
		/// </summary>
		public const byte TAG_TYPE_MIFARE_CLASSIC = 0;

		/// <summary>
		/// </summary>
		public const byte TAG_TYPE_TYPE1 = 1;

		/// <summary>
		/// </summary>
		public const byte TAG_TYPE_TYPE2 = 2;

		/// <summary>
		/// </summary>
		public const byte STATE_INITIALIZATION = 0;

		/// <summary>
		/// </summary>
		public const byte STATE_IDLE = 128;

		/// <summary>
		/// </summary>
		public const byte STATE_ERROR = 192;

		/// <summary>
		/// </summary>
		public const byte STATE_REQUEST_TAG_ID = 2;

		/// <summary>
		/// </summary>
		public const byte STATE_REQUEST_TAG_ID_READY = 130;

		/// <summary>
		/// </summary>
		public const byte STATE_REQUEST_TAG_ID_ERROR = 194;

		/// <summary>
		/// </summary>
		public const byte STATE_AUTHENTICATING_MIFARE_CLASSIC_PAGE = 3;

		/// <summary>
		/// </summary>
		public const byte STATE_AUTHENTICATING_MIFARE_CLASSIC_PAGE_READY = 131;

		/// <summary>
		/// </summary>
		public const byte STATE_AUTHENTICATING_MIFARE_CLASSIC_PAGE_ERROR = 195;

		/// <summary>
		/// </summary>
		public const byte STATE_WRITE_PAGE = 4;

		/// <summary>
		/// </summary>
		public const byte STATE_WRITE_PAGE_READY = 132;

		/// <summary>
		/// </summary>
		public const byte STATE_WRITE_PAGE_ERROR = 196;

		/// <summary>
		/// </summary>
		public const byte STATE_REQUEST_PAGE = 5;

		/// <summary>
		/// </summary>
		public const byte STATE_REQUEST_PAGE_READY = 133;

		/// <summary>
		/// </summary>
		public const byte STATE_REQUEST_PAGE_ERROR = 197;

		/// <summary>
		/// </summary>
		public const byte KEY_A = 0;

		/// <summary>
		/// </summary>
		public const byte KEY_B = 1;


		/// <summary>
		///  This callback is called if the state of the NFC/RFID Bricklet changes.
		///  See <see cref="Tinkerforge.BrickletNFCRFID.GetState"/> for more information about the possible states.
		/// </summary>
		public event StateChangedEventHandler StateChangedCallback;
		/// <summary>
		/// </summary>
		public delegate void StateChangedEventHandler(BrickletNFCRFID sender, byte state, bool idle);

		/// <summary>
		/// </summary>
		public event StateChangedEventHandler StateChanged // for backward compatibility
		{
			add { StateChangedCallback += value; }
			remove { StateChangedCallback -= value; }
		}

		/// <summary>
		///  Creates an object with the unique device ID <c>uid</c> and adds  it to
		///  the IPConnection <c>ipcon</c>.
		/// </summary>
		public BrickletNFCRFID(string uid, IPConnection ipcon) : base(uid, ipcon)
		{
			apiVersion[0] = 2;
			apiVersion[1] = 0;
			apiVersion[2] = 0;

			callbackWrappers[CALLBACK_STATE_CHANGED] = new CallbackWrapper(OnStateChangedCallback);

			responseExpected[FUNCTION_REQUEST_TAG_ID] = ResponseExpectedFlag.FALSE;
			responseExpected[FUNCTION_GET_TAG_ID] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_GET_STATE] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_AUTHENTICATE_MIFARE_CLASSIC_PAGE] = ResponseExpectedFlag.FALSE;
			responseExpected[FUNCTION_WRITE_PAGE] = ResponseExpectedFlag.FALSE;
			responseExpected[FUNCTION_REQUEST_PAGE] = ResponseExpectedFlag.FALSE;
			responseExpected[FUNCTION_GET_PAGE] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_GET_IDENTITY] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[CALLBACK_STATE_CHANGED] = ResponseExpectedFlag.ALWAYS_FALSE;
		}

		/// <summary>
		///  To read or write a tag that is in proximity of the NFC/RFID Bricklet you
		///  first have to call this function with the expected tag type as parameter.
		///  It is no problem if you don't know the tag type. You can cycle through
		///  the available tag types until the tag gives an answer to the request.
		///  
		///  Current the following tag types are supported:
		///  
		///  * Mifare Classic
		///  * NFC Forum Type 1
		///  * NFC Forum Type 2
		///  
		///  After you call <see cref="Tinkerforge.BrickletNFCRFID.RequestTagID"/> the NFC/RFID Bricklet will try to read
		///  the tag ID from the tag. After this process is done the state will change.
		///  You can either register the <see cref="Tinkerforge.BrickletNFCRFID.StateChangedCallback"/> callback or you can poll
		///  <see cref="Tinkerforge.BrickletNFCRFID.GetState"/> to find out about the state change.
		///  
		///  If the state changes to *RequestTagIDError* it means that either there was
		///  no tag present or that the tag is of an incompatible type. If the state
		///  changes to *RequestTagIDReady* it means that a compatible tag was found
		///  and that the tag ID could be read out. You can now get the tag ID by
		///  calling <see cref="Tinkerforge.BrickletNFCRFID.GetTagID"/>.
		///  
		///  If two tags are in the proximity of the NFC/RFID Bricklet, this
		///  function will cycle through the tags. To select a specific tag you have
		///  to call <see cref="Tinkerforge.BrickletNFCRFID.RequestTagID"/> until the correct tag id is found.
		///  
		///  In case of any *Error* state the selection is lost and you have to
		///  start again by calling <see cref="Tinkerforge.BrickletNFCRFID.RequestTagID"/>.
		/// </summary>
		public void RequestTagID(byte tagType)
		{
			byte[] request = CreateRequestPacket(9, FUNCTION_REQUEST_TAG_ID);
			LEConverter.To((byte)tagType, 8, request);

			SendRequest(request);

		}

		/// <summary>
		///  Returns the tag type, tag ID and the length of the tag ID
		///  (4 or 7 bytes are possible length). This function can only be called if the
		///  NFC/RFID is currently in one of the *Ready* states. The returned ID
		///  is the ID that was saved through the last call of <see cref="Tinkerforge.BrickletNFCRFID.RequestTagID"/>.
		///  
		///  To get the tag ID of a tag the approach is as follows:
		///  
		///  1. Call <see cref="Tinkerforge.BrickletNFCRFID.RequestTagID"/>
		///  2. Wait for state to change to *RequestTagIDReady* (see <see cref="Tinkerforge.BrickletNFCRFID.GetState"/> or
		///     <see cref="Tinkerforge.BrickletNFCRFID.StateChangedCallback"/> callback)
		///  3. Call <see cref="Tinkerforge.BrickletNFCRFID.GetTagID"/>
		/// </summary>
		public void GetTagID(out byte tagType, out byte tidLength, out byte[] tid)
		{
			byte[] request = CreateRequestPacket(8, FUNCTION_GET_TAG_ID);

			byte[] response = SendRequest(request);

			tagType = LEConverter.ByteFrom(8, response);
			tidLength = LEConverter.ByteFrom(9, response);
			tid = LEConverter.ByteArrayFrom(10, response, 7);
		}

		/// <summary>
		///  Returns the current state of the NFC/RFID Bricklet.
		///  
		///  On startup the Bricklet will be in the *Initialization* state. The
		///  initialization will only take about 20ms. After that it changes to *Idle*.
		///  
		///  The functions of this Bricklet can be called in the *Idle* state and all of
		///  the *Ready* and *Error* states.
		///  
		///  Example: If you call <see cref="Tinkerforge.BrickletNFCRFID.RequestPage"/>, the state will change to
		///  *RequestPage* until the reading of the page is finished. Then it will change
		///  to either *RequestPageReady* if it worked or to *RequestPageError* if it
		///  didn't. If the request worked you can get the page by calling <see cref="Tinkerforge.BrickletNFCRFID.GetPage"/>.
		///  
		///  The same approach is used analogously for the other API functions.
		/// </summary>
		public void GetState(out byte state, out bool idle)
		{
			byte[] request = CreateRequestPacket(8, FUNCTION_GET_STATE);

			byte[] response = SendRequest(request);

			state = LEConverter.ByteFrom(8, response);
			idle = LEConverter.BoolFrom(9, response);
		}

		/// <summary>
		///  Mifare Classic tags use authentication. If you want to read from or write to
		///  a Mifare Classic page you have to authenticate it beforehand.
		///  Each page can be authenticated with two keys: A (``key_number`` = 0) and B
		///  (``key_number`` = 1). A new Mifare Classic
		///  tag that has not yet been written to can can be accessed with key A
		///  and the default key ``[0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF]``.
		///  
		///  The approach to read or write a Mifare Classic page is as follows:
		///  
		///  1. Call <see cref="Tinkerforge.BrickletNFCRFID.RequestTagID"/>
		///  2. Wait for state to change to *RequestTagIDReady* (see <see cref="Tinkerforge.BrickletNFCRFID.GetState"/>
		///     or <see cref="Tinkerforge.BrickletNFCRFID.StateChangedCallback"/> callback)
		///  3. If looking for a specific tag then call <see cref="Tinkerforge.BrickletNFCRFID.GetTagID"/> and check if the
		///     expected tag was found, if it was not found got back to step 1
		///  4. Call <see cref="Tinkerforge.BrickletNFCRFID.AuthenticateMifareClassicPage"/> with page and key for the page
		///  5. Wait for state to change to *AuthenticatingMifareClassicPageReady* (see
		///     <see cref="Tinkerforge.BrickletNFCRFID.GetState"/> or <see cref="Tinkerforge.BrickletNFCRFID.StateChangedCallback"/> callback)
		///  6. Call <see cref="Tinkerforge.BrickletNFCRFID.RequestPage"/> or <see cref="Tinkerforge.BrickletNFCRFID.WritePage"/> to read/write page
		/// </summary>
		public void AuthenticateMifareClassicPage(int page, byte keyNumber, byte[] key)
		{
			byte[] request = CreateRequestPacket(17, FUNCTION_AUTHENTICATE_MIFARE_CLASSIC_PAGE);
			LEConverter.To((short)page, 8, request);
			LEConverter.To((byte)keyNumber, 10, request);
			LEConverter.To((byte[])key, 11, 6, request);

			SendRequest(request);

		}

		/// <summary>
		///  Writes 16 bytes starting from the given page. How many pages are written
		///  depends on the tag type. The page sizes are as follows:
		///  
		///  * Mifare Classic page size: 16 byte (one page is written)
		///  * NFC Forum Type 1 page size: 8 byte (two pages are written)
		///  * NFC Forum Type 2 page size: 4 byte (four pages are written)
		///  
		///  The general approach for writing to a tag is as follows:
		///  
		///  1. Call <see cref="Tinkerforge.BrickletNFCRFID.RequestTagID"/>
		///  2. Wait for state to change to *RequestTagIDReady* (see <see cref="Tinkerforge.BrickletNFCRFID.GetState"/> or
		///     <see cref="Tinkerforge.BrickletNFCRFID.StateChangedCallback"/> callback)
		///  3. If looking for a specific tag then call <see cref="Tinkerforge.BrickletNFCRFID.GetTagID"/> and check if the
		///     expected tag was found, if it was not found got back to step 1
		///  4. Call <see cref="Tinkerforge.BrickletNFCRFID.WritePage"/> with page number and data
		///  5. Wait for state to change to *WritePageReady* (see <see cref="Tinkerforge.BrickletNFCRFID.GetState"/> or
		///     <see cref="Tinkerforge.BrickletNFCRFID.StateChangedCallback"/> callback)
		///  
		///  If you use a Mifare Classic tag you have to authenticate a page before you
		///  can write to it. See <see cref="Tinkerforge.BrickletNFCRFID.AuthenticateMifareClassicPage"/>.
		/// </summary>
		public void WritePage(int page, byte[] data)
		{
			byte[] request = CreateRequestPacket(26, FUNCTION_WRITE_PAGE);
			LEConverter.To((short)page, 8, request);
			LEConverter.To((byte[])data, 10, 16, request);

			SendRequest(request);

		}

		/// <summary>
		///  Reads 16 bytes starting from the given page and stores them into a buffer.
		///  The buffer can then be read out with <see cref="Tinkerforge.BrickletNFCRFID.GetPage"/>.
		///  How many pages are read depends on the tag type. The page sizes are
		///  as follows:
		///  
		///  * Mifare Classic page size: 16 byte (one page is read)
		///  * NFC Forum Type 1 page size: 8 byte (two pages are read)
		///  * NFC Forum Type 2 page size: 4 byte (four pages are read)
		///  
		///  The general approach for reading a tag is as follows:
		///  
		///  1. Call <see cref="Tinkerforge.BrickletNFCRFID.RequestTagID"/>
		///  2. Wait for state to change to *RequestTagIDReady* (see <see cref="Tinkerforge.BrickletNFCRFID.GetState"/>
		///     or <see cref="Tinkerforge.BrickletNFCRFID.StateChangedCallback"/> callback)
		///  3. If looking for a specific tag then call <see cref="Tinkerforge.BrickletNFCRFID.GetTagID"/> and check if the
		///     expected tag was found, if it was not found got back to step 1
		///  4. Call <see cref="Tinkerforge.BrickletNFCRFID.RequestPage"/> with page number
		///  5. Wait for state to change to *RequestPageReady* (see <see cref="Tinkerforge.BrickletNFCRFID.GetState"/>
		///     or <see cref="Tinkerforge.BrickletNFCRFID.StateChangedCallback"/> callback)
		///  6. Call <see cref="Tinkerforge.BrickletNFCRFID.GetPage"/> to retrieve the page from the buffer
		///  
		///  If you use a Mifare Classic tag you have to authenticate a page before you
		///  can read it. See <see cref="Tinkerforge.BrickletNFCRFID.AuthenticateMifareClassicPage"/>.
		/// </summary>
		public void RequestPage(int page)
		{
			byte[] request = CreateRequestPacket(10, FUNCTION_REQUEST_PAGE);
			LEConverter.To((short)page, 8, request);

			SendRequest(request);

		}

		/// <summary>
		///  Returns 16 bytes of data from an internal buffer. To fill the buffer
		///  with specific pages you have to call <see cref="Tinkerforge.BrickletNFCRFID.RequestPage"/> beforehand.
		/// </summary>
		public byte[] GetPage()
		{
			byte[] request = CreateRequestPacket(8, FUNCTION_GET_PAGE);

			byte[] response = SendRequest(request);

			return LEConverter.ByteArrayFrom(8, response, 16);
		}

		/// <summary>
		///  Returns the UID, the UID where the Bricklet is connected to,
		///  the position, the hardware and firmware version as well as the
		///  device identifier.
		///  
		///  The position can be 'a', 'b', 'c' or 'd'.
		///  
		///  The device identifier numbers can be found :ref:`here &lt;device_identifier&gt;`.
		///  |device_identifier_constant|
		/// </summary>
		public override void GetIdentity(out string uid, out string connectedUid, out char position, out byte[] hardwareVersion, out byte[] firmwareVersion, out int deviceIdentifier)
		{
			byte[] request = CreateRequestPacket(8, FUNCTION_GET_IDENTITY);

			byte[] response = SendRequest(request);

			uid = LEConverter.StringFrom(8, response, 8);
			connectedUid = LEConverter.StringFrom(16, response, 8);
			position = LEConverter.CharFrom(24, response);
			hardwareVersion = LEConverter.ByteArrayFrom(25, response, 3);
			firmwareVersion = LEConverter.ByteArrayFrom(28, response, 3);
			deviceIdentifier = LEConverter.UShortFrom(31, response);
		}

		/// <summary>
		/// </summary>
		protected void OnStateChangedCallback(byte[] response)
		{
			byte state = LEConverter.ByteFrom(8, response);
			bool idle = LEConverter.BoolFrom(9, response);

			var handler = StateChangedCallback;
			if(handler != null)
			{
				handler(this, state, idle);
			}
		}
	}
}
